
//Code originates from http://en.literateprograms.org/RGB_to_HSV_color_space_conversion_%28C%29
//Author wasn't retrievable at that moment, please fill in when available.
/*
Copyright (c) 2006 <copyright holders>

Permission is hereby granted, free of charge, to any person
obtaining a copy of this software and associated documentation
files (the "Software"), to deal in the Software without
restriction, including without limitation the rights to use,
copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the
Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be
included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/



#define MIN3(x,y,z) ((y)<=(z)?((x)<=(y)?(x):(y)):((x)<=(z)?(x):(z)))
#define MAX3(x,y,z) ((y)>=(z)?((x)>=(y)?(x):(y)):((x)>=(z)?(x):(z)))

void rgb_to_hsv(unsigned char r, unsigned char g, unsigned char b,
     unsigned char *h, unsigned char *s, unsigned char *v ) {

    unsigned char rgb_min, rgb_max;
    rgb_min = MIN3(r, g, b);
    rgb_max = MAX3(r, g, b);

    *v = rgb_max;
    if (*v == 0) {
	*h = *s = 0;
	return;
    }
    *s = 255*(rgb_max - rgb_min)/ *v;
    if (*s == 0) {
	*h = 0;
	return;
    }

    /* Compute hue */
    if (rgb_max == r) {
	*h = 0 + 43*(g - b)/(rgb_max - rgb_min);
    } else if (rgb_max == g) {
	*h = 85 + 43*(b - r)/(rgb_max - rgb_min);
    } else /* rgb_max == rgb.b */ {
	*h = 171 + 43*(r - g)/(rgb_max - rgb_min);
    }
   return;
}

